; V.Pohlers 20.05.2009
; Wrapper fr FDTEST18 fr CP/M
; zeigt, wie Z9001-OS-Programme unter CP/M lauffhig werden

		cseg
		org 100h

; Kopieren Programm an Zielbereich
		ld	hl, 160h	; Beginn des Programms (hinter Loader)
		ld	de, loc_4000	; Zieladresse
		ld	bc, 11D0h	; Lnge
		ldir

; Wegsichern CALL BDOS, User, I/O-Byte
		ld	hl, 1		; DE = 51D0
		ld	bc, 4
		ldir
; Wegsichern I/O-Treiber-Zuordnung
		ld	hl, 0EFC9h	; DE = 51D4
		ld	bc, 20h
		ldir
; vgl. fr Folgendes OS Z9001, INIT
; Stack und Interrupt-Vektor
		di
		ld	sp, 200h	; Standard-Z9001-Stack
		ld	a, 2
		ld	i, a		; Standard-Z9001-Interrupt-Vektor
; System-PIO init.
		inc	a		; A = 3
		out	(8Ah), a	; PIO1AS Interrupt aus
		ld	a, 0CFh
		out	(8Ah), a	; PIO1AS Mode 3
		xor	a		; A = 0
		out	(8Ah), a	; PIO1AS alles Ausgabebits
		out	(88h), a	; PIO1AD alles 0 (24Z, BORDER black, GRAPHIC off, ..)
; Standard BOS und WBOOT-Einsprung
		ld	hl, 0F314h	; Z9001-OS-BOS
		ld	(6), hl
		ld	hl, 0F6AEh	; Z9001-OS-WBOOT
		ld	(1), hl
; Standard-Z9001-Interrupt-Tabelle
		ld	hl, 0FCB0h	; INTV Interruptadressen-Tabelle
		ld	de, 200h
		ld	bc, 12h
		ldir
; I/O-Byte
		ld	a, (4)
		and	0FCh		; I/O CONST = 00
		or	1		; I/O CONST = 01 = CRT setzen
		call	0F712h		; IOST1, Teilinitialisierung
; Programm starten
		jp	loc_400D




; ---------------------------------------------------------------------------
		org 160

		phase 4000h

loc_4000:	jp	loc_400D
aFdtest18:	db 'FDTEST18',0
		db    0
loc_400D:	...			; CODE XREF: main:loc_4000j
; das Programm muss die Interrupts wieder einschalten !!!




; Programm-Ende
; Hier wird der Aussprung gepatcht
; statt (JP 0 ???)

loc_4FBF:	ld	de, aEnde	; "\r\n\r\n	 - ENDE	-	\r\n\r\n"
		ld	c, 9
		call	5
		jp	loc_51BA	<-- gepatcht


		...

		dephase

; ---------------------------------------------------------------------------


loc_51BA:
; Rcksichern CALL BDOS, User, I/O-Byte
		ld	hl, 51D0h
		ld	de, 1
		ld	bc, 4
		ldir
; Rcksichern I/O-Treiber-Zuordnung
		ld	de, 0EFC9h
		ld	bc, 20h
		ldir
; CP/M-Warmstart
		jp	0


		end
